diff --git a/app/controllers/application_controller.rb b/app/controllers/application_controller.rb
index e43e0d6..0a4bb6d 100644
--- a/app/controllers/application_controller.rb
+++ b/app/controllers/application_controller.rb
@@ -3,6 +3,7 @@
 
 class ApplicationController < ActionController::Base
   protect_from_forgery # See ActionController::RequestForgeryProtection for details
+  rescue_from ActionController::RoutingError, :with => :no_puppetclass_documentation_handler
 
   # standard layout to all controllers
   layout 'standard'
@@ -11,6 +12,18 @@ class ApplicationController < ActionController::Base
   before_filter :require_ssl, :require_login
   before_filter :load_tabs, :manage_tabs, :unless => :request_json?
   before_filter :welcome, :detect_notices, :only => :index, :unless => :request_json?
+  before_filter :authorize, :except => :login
+
+  # Authorize the user for the requested action
+  def authorize(ctrl = params[:controller], action = params[:action])
+    return true if request.xhr?
+    allowed = User.current.allowed_to?({:controller => ctrl, :action => action})
+    allowed ? true : deny_access
+  end
+
+  def deny_access
+    User.current.logged? ? render_403 : require_login
+  end
 
   protected
 
@@ -25,32 +38,32 @@ class ApplicationController < ActionController::Base
 
 
   # Force a user to login if authentication is enabled
-  # Sets @user to the logged in user, or to admin if logins are not used
+  # Sets User.current to the logged in user, or to admin if logins are not used
   def require_login
-    unless session[:user] and @user = User.find(session[:user])
+    unless session[:user] and User.current = User.find(session[:user])
       # User is not found or first login
       if SETTINGS[:login] and SETTINGS[:login] == true
         # authentication is enabled
         if request_json?
           # JSON requests (REST API calls) use basic http authenitcation and should not use/store cookies
-          @user = authenticate_or_request_with_http_basic { |u, p| User.try_to_login(u, p) }
-          return !@user.nil?
+          User.current = authenticate_or_request_with_http_basic { |u, p| User.try_to_login(u, p) }
+          return !User.current.nil?
         end
         session[:original_uri] = request.request_uri # keep the old request uri that we can redirect later on
         redirect_to login_users_path and return
       else
         # We assume we always have a user logged in, if authentication is disabled, the user is the build-in admin account.
-        unless @user = User.find_by_login("admin")
+        unless User.current = User.find_by_login("admin")
           flash[:foreman_error] = "Unable to find internal system admin account - Recreating . . ."
-          @user = User.create_admin
+          User.current = User.current = User.create_admin
         end
-        session[:user] = @user.id unless request_json?
+        session[:user] = User.current.id unless request_json?
       end
     end
   end
 
   def current_user
-    @user
+    User.current
   end
 
   def invalid_request
@@ -103,9 +116,9 @@ class ApplicationController < ActionController::Base
     session[:last_controller] = controller_name
     self.active_tab           = "" if @controller_changed
 
-    return if params[:tab_name].empty? or params[:action] != "index"
+    return true if params[:tab_name].empty? or params[:action] != "index"
 
-    if    params[:tab_name] == "Reset"
+    if params[:tab_name] == "Reset"
       self.active_tab    = ""
     elsif params[:remove_me] and @tabs.has_key? params[:tab_name]
       @tabs.delete params[:tab_name]
@@ -122,4 +135,33 @@ class ApplicationController < ActionController::Base
     end
   end
 
+  def require_admin
+    unless User.current.admin?
+      render_403
+      return false
+    end
+    true
+  end
+
+  def render_403
+    respond_to do |format|
+      format.html { render :template => "common/403", :layout => (request.xhr? ? false : 'standard'), :status => 403 }
+      format.atom { head 403 }
+      format.yaml { head 403 }
+      format.yml  { head 403 }
+      format.xml  { head 403 }
+      format.json { head 403 }
+    end
+    return false
+  end
+
+  # this has to be in the application controller, as the new request (for puppetdoc) url is not controller specific.
+  def no_puppetclass_documentation_handler(exception)
+    if exception.message =~ /No route matches "\/puppet\/rdoc\/([^\/]+)\/classes\/(.+?)\.html/
+      render :template => "puppetclasses/no_route", :locals => {:environment => $1, :name => $2.gsub("/","::")}, :layout => false
+    else
+      local_request? ? rescue_action_locally(exception) : rescue_action_in_public(exception)
+    end
+  end
+
 end
diff --git a/app/controllers/environments_controller.rb b/app/controllers/environments_controller.rb
index 6f9cef5..b9a105e 100644
--- a/app/controllers/environments_controller.rb
+++ b/app/controllers/environments_controller.rb
@@ -1,6 +1,5 @@
 class EnvironmentsController < ApplicationController
   include Foreman::Controller::Environments
-  rescue_from ActionController::RoutingError, :with => :no_puppetclass_documentation_handler
 
   before_filter :find_environment, :only => %w{show edit update destroy}
 
diff --git a/app/controllers/fact_values_controller.rb b/app/controllers/fact_values_controller.rb
index 1217c4c..bb1496c 100644
--- a/app/controllers/fact_values_controller.rb
+++ b/app/controllers/fact_values_controller.rb
@@ -1,6 +1,7 @@
 class FactValuesController < ApplicationController
-  skip_before_filter :require_ssl, :only => :create
-  skip_before_filter :require_login, :only => :create
+  skip_before_filter :require_ssl,               :only => :create
+  skip_before_filter :require_login,             :only => :create
+  skip_before_filter :authorize,                 :only => :create
   skip_before_filter :verify_authenticity_token, :only => :create
 
   # avoids storing the facts data in the log files
diff --git a/app/controllers/hosts_controller.rb b/app/controllers/hosts_controller.rb
index cd033d1..7d7b029 100644
--- a/app/controllers/hosts_controller.rb
+++ b/app/controllers/hosts_controller.rb
@@ -8,15 +8,20 @@ class HostsController < ApplicationController
     :multiple_enable, :multiple_disable, :submit_multiple_disable, :submit_multiple_enable]
   before_filter :find_host, :only => %w[show edit update destroy puppetrun setBuild cancelBuild report
     reports facts storeconfig_klasses clone externalNodes pxe_config]
+  before_filter :authorize
 
   filter_parameter_logging :root_pass
   helper :hosts, :reports
 
   def index
+
+    # restrict allowed hosts list based on the user permissions
+    @search = User.current.admin? ? Host.search(params[:search]) : Host.my_hosts.search(params[:search])
+
     respond_to do |format|
-      @search = Host.search(params[:search])
       format.html do
-        @hosts = @search.paginate :page => params[:page], :include => [:hostgroup, :domain, :operatingsystem, :environment, :model]
+        # You can see a host if you can CRUD it
+        @hosts = @search.paginate :page => params[:page], :include => [:hostgroup, :domain, :operatingsystem, :environment, :model, :fact_values]
         @via    = "fact_values_"
         @last_reports = Report.maximum(:id, :group => :host_id, :conditions => {:host_id => @hosts})
       end
@@ -343,7 +348,8 @@ class HostsController < ApplicationController
     hosts.delete_if {|host| host.destroy}
 
     session[:selected] = []
-    flash[:foreman_notice] = hosts.empty? ? "Destroyed selected hosts" : "The following hosts were not deleted: #{hosts.map(&:name).join('<br/>')}"
+    missed_hosts       = hosts.map(&:name).join('<br/>')
+    flash[:foreman_notice] = hosts.empty? ? "Destroyed selected hosts" : "The following hosts were not deleted: #{missed_hosts}"
     redirect_to(hosts_path)
   end
 
@@ -487,7 +493,8 @@ class HostsController < ApplicationController
     action = mode ? "enabled" : "disabled"
 
     session[:selected] = []
-    flash[:foreman_notice] = @hosts.empty? ? "#{action.capitalize} selected hosts" : "The following hosts were not #{action}: #{hosts.map(&:name).join('<br/>')}"
+    missed_hosts       = hosts.map(&:name).join('<br/>')
+    flash[:foreman_notice] = @hosts.empty? ? "#{action.capitalize} selected hosts" : "The following hosts were not #{action}: #{missed_hosts}"
     redirect_to(hosts_path) and return
   end
 
@@ -503,7 +510,7 @@ class HostsController < ApplicationController
     @search = list.search(params[:search])
     respond_to do |format|
       format.html do
-        @hosts = @search.paginate :page => params[:page], :include => [:hostgroup, :domain, :operatingsystem, :environment, :model]
+        @hosts = @search.paginate :page => params[:page], :include => [:hostgroup, :domain, :operatingsystem, :environment, :model, :fact_values]
         @via    = "fact_values_"
         @last_reports = Report.maximum(:id, :group => :host_id, :conditions => {:host_id => @hosts})
         @title = title
diff --git a/app/controllers/notices_controller.rb b/app/controllers/notices_controller.rb
index 6344cbe..f07bd9d 100644
--- a/app/controllers/notices_controller.rb
+++ b/app/controllers/notices_controller.rb
@@ -1,12 +1,9 @@
 class NoticesController < ApplicationController
+  skip_before_filter :authorize, :only => :destroy
+
   def destroy
     @notice = Notice.find(params[:id])
-    if @notice.global
-      @notice.destroy
-    else
-      @notice.users.delete(current_user)
-      @notice.destroy unless @notice.users.any?
-    end
+    @notice.destroy_notice
     redirect_to :back
   end
 end
diff --git a/app/controllers/puppetclasses_controller.rb b/app/controllers/puppetclasses_controller.rb
index c272508..b26b845 100644
--- a/app/controllers/puppetclasses_controller.rb
+++ b/app/controllers/puppetclasses_controller.rb
@@ -1,6 +1,5 @@
 class PuppetclassesController < ApplicationController
   include Foreman::Controller::Environments
-  rescue_from ActionController::RoutingError, :with => :no_puppetclass_documentation_handler
 
   def index
     respond_to do |format|
diff --git a/app/controllers/reports_controller.rb b/app/controllers/reports_controller.rb
index e740d95..951f25b 100644
--- a/app/controllers/reports_controller.rb
+++ b/app/controllers/reports_controller.rb
@@ -1,6 +1,7 @@
 class ReportsController < ApplicationController
-  skip_before_filter :require_login, :only => :create
-  skip_before_filter :require_ssl, :only => :create
+  skip_before_filter :require_login,             :only => :create
+  skip_before_filter :require_ssl,               :only => :create
+  skip_before_filter :authorize,                 :only => :create
   skip_before_filter :verify_authenticity_token, :only => :create
   helper :reports
 
diff --git a/app/controllers/roles_controller.rb b/app/controllers/roles_controller.rb
new file mode 100644
index 0000000..612a027
--- /dev/null
+++ b/app/controllers/roles_controller.rb
@@ -0,0 +1,80 @@
+# redMine - project management software
+# Copyright (C) 2006  Jean-Philippe Lang
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+class RolesController < ApplicationController
+  before_filter :require_admin
+
+  def index
+    @search = Role.search(params[:search])
+    @roles = @search.paginate(:page => params[:page], :order => "builtin ASC, name ASC")
+  end
+
+  def new
+    # Prefills the form with 'default user' role permissions
+    @role        = Role.new({:permissions => Role.default_user.permissions})
+    @permissions = @role.setable_permissions
+  end
+
+  def create
+    @role = Role.new(params[:role])
+    @permissions = @role.setable_permissions
+    if @role.save
+      flash[:foreman_notice] = "#{@role.name} succcessfully created"
+      redirect_to roles_url
+    else
+      render :action => 'new'
+    end
+  end
+
+  def edit
+    @role = Role.find(params[:id])
+    @permissions = @role.setable_permissions
+  end
+
+  def update
+    @role = Role.find(params[:id])
+    if @role.update_attributes(params[:role])
+      flash[:foreman_notice] = "#{@role.name} successfully updated"
+      redirect_to roles_url
+    else
+      render :action => 'edit'
+    end
+  end
+
+  def destroy
+    @role = Role.find(params[:id])
+    if @role.destroy
+      flash[:foreman_notice] = "Successfully destroyed role."
+    else
+      flash[:foreman_error] = @role.errors.full_messages.join("<br/>")
+    end
+    redirect_to roles_url
+  end
+
+  def report
+    @roles = Role.all(:order => 'builtin, name')
+    @permissions = Foreman::AccessControl.permissions.select { |p| !p.public? }
+    if request.post?
+      @roles.each do |role|
+        role.permissions = params[:permissions][role.id.to_s]
+        role.save
+      end
+      flash[:foreman_notice] = "All non public permissions successfuly updated"
+      redirect_to roles_url
+    end
+  end
+end
diff --git a/app/controllers/usergroups_controller.rb b/app/controllers/usergroups_controller.rb
index e3d788c..87377b5 100644
--- a/app/controllers/usergroups_controller.rb
+++ b/app/controllers/usergroups_controller.rb
@@ -1,6 +1,6 @@
 class UsergroupsController < ApplicationController
   def index
-    @usergroups = Usergroup.all
+    @usergroups = Usergroup.all(:order => "name")
   end
 
   def new
diff --git a/app/controllers/users_controller.rb b/app/controllers/users_controller.rb
index 88485e8..0aee9cc 100644
--- a/app/controllers/users_controller.rb
+++ b/app/controllers/users_controller.rb
@@ -2,6 +2,7 @@ class UsersController < ApplicationController
 
   filter_parameter_logging :password, :password_confirmation
   skip_before_filter :require_login, :only => [:login, :logout]
+  skip_before_filter :authorize, :only => [:login, :logout]
 
   def index
     # set defaults search order - cant use default scope due to bug in AR
@@ -21,6 +22,7 @@ class UsersController < ApplicationController
     @user = User.new(params[:user])
     @user.admin = params[:admin]
     if @user.save
+      @user.roles = Role.name_is("Anonymous")
       flash[:foreman_notice] = "Successfully created user."
       redirect_to users_url
     else
@@ -30,13 +32,26 @@ class UsersController < ApplicationController
 
   def edit
     @user = User.find(params[:id])
+    if @user.user_facts.count == 0
+      user_fact = @user.user_facts.build :operator => "==", :andor => "or"
+      user_fact.fact_name_id = Puppet::Rails::FactName.first.id if Puppet::Rails::FactName.first
+      true
+    end
   end
 
   def update
     @user = User.find(params[:id])
     admin = params[:user].delete :admin
+    # Remove keys for resticted variables when the user is granted minimal access only to their own account
+    if @minimal_edit
+      for key in params[:user].keys
+        params[:user].delete key unless %w{password_confirmation password mail firstname lastname}.include? key
+      end
+    end
     if @user.update_attributes(params[:user])
-      @user.update_attribute :admin, admin
+      # Only an admin can update admin attribute of another use
+      # this is required, as the admin field is blacklisted above
+      @user.update_attribute(:admin, admin) if User.current.admin
       flash[:foreman_notice] = "Successfully updated user."
       redirect_to users_url
     else
@@ -46,7 +61,7 @@ class UsersController < ApplicationController
 
   def destroy
     user = User.find(params[:id])
-    if user == current_user
+    if user == User.current
       flash[:foreman_notice] = "You are currently logged in, suicidal?"
       redirect_to :back and return
     end
@@ -80,10 +95,11 @@ class UsersController < ApplicationController
   # Called from the logout link
   # Clears the rails session and redirects to the login action
   def logout
-    session[:user] = @user = nil
+    session[:user] = @user = User.current = nil
     if flash[:foreman_notice] or flash[:foreman_error]
       flash.keep
     else
+      session.clear
       flash[:foreman_notice] = "Logged out - See you soon"
     end
     redirect_to login_users_path
@@ -99,4 +115,18 @@ class UsersController < ApplicationController
     end
   end
 
+  private
+
+  def authorize(ctrl = params[:controller], action = params[:action])
+    # Minimal edit is true when the user is granted access to just their
+    # own account details
+    @minimal_edit = false
+    return true if User.current.allowed_to?({:controller => ctrl, :action => action})
+    if action =~ /edit|update/ and params[:id] == User.current.id.to_s
+      return @minimal_edit=true
+    else
+      deny_access and return
+    end
+  end
+
 end
diff --git a/app/helpers/application_helper.rb b/app/helpers/application_helper.rb
index 1c68dc6..81af172 100644
--- a/app/helpers/application_helper.rb
+++ b/app/helpers/application_helper.rb
@@ -1,6 +1,9 @@
-# Methods added to this helper will be available to all templates in the application.
+# Methods added to this helper will be available to all templates in the application
 module ApplicationHelper
 
+  def contract model
+    model.to_s
+  end
   def graph(type,opts = {})
     Gchart.send(type, {:size => '400x150', :bg => "E6DFCF", :format => "image_tag"}.merge(opts))
   end
@@ -10,13 +13,18 @@ module ApplicationHelper
   end
 
   def edit_habtm klass, association
-    render :partial => 'common/edit_habtm', :locals =>{ :klass => klass, :associations => association.all.delete_if{|e| e == klass}}
+    render :partial => 'common/edit_habtm', :locals =>{ :klass => klass, :associations => association.all.sort.delete_if{|e| e == klass}}
   end
 
   def link_to_remove_fields(name, f)
     f.hidden_field(:_destroy) + link_to_function(image_tag("false.png", :title => "remove"), "remove_fields(this)")
   end
 
+  # Creates a link to a javascript function that creates field entries for the association on the web page
+  # +name+       : String containing links's text
+  # +f+          : FormBuiler object
+  # +association : The field are created to allow entry into this association
+  # +partial+    : String containing an optional partial into which we render
   def link_to_add_fields(name, f, association, partial = nil)
     new_object = f.object.class.reflect_on_association(association).klass.new
     fields = f.fields_for(association, new_object, :child_index => "new_#{association}") do |builder|
@@ -52,6 +60,12 @@ module ApplicationHelper
       :position => {:after => {:success => "selected_classes" }}
   end
 
+  def check_all_links(form_name)
+    link_to_function("Check all", "checkAll('#{form_name}', true)") +
+    " | " +
+    link_to_function("Uncheck all", "checkAll('#{form_name}', false)")
+  end
+
   def searchtab title, search, options
     opts = {:action => params[:action], :tab_name => title, :search => search}
     selected_class = options[:selected] ? "selectedtab" : ""
@@ -81,4 +95,45 @@ module ApplicationHelper
     return param.to_i unless param.empty?
     return @fact_name_id if @fact_name_id
   end
+
+  # Return true if user is authorized for controller/action, otherwise false
+  # +controller+ : String or symbol for the controller
+  # +action+     : String or symbol for the action
+  def authorized_for(controller, action)
+    User.current.allowed_to?({:controller => controller, :action => action}) rescue false
+  end
+
+  # Display a link if user is authorized, otherwise a string
+  # +name+    : String to be displayed
+  # +options+ : Hash containing
+  #             :enable_link  : Boolean indicating whether the link is to be displayed
+  #             :controlller  : String or Symbol representing the controller
+  #             :auth_action  : String or Symbol representing the action to be used for authorization checks
+  # +html_options+ : Hash containing html options for the link or span
+  def link_to_if_authorized(name, options = {}, html_options = {})
+    enable_link = options.has_key?(:enable_link) ? options.delete(:enable_link) : true
+    auth_action = options.delete :auth_action
+    if enable_link
+      link_to_if authorized_for(options[:controller] || params[:controller], auth_action || options[:action]), name, options, html_options
+    else
+      content_tag(:span, name, {:class => "entry"}.merge(html_options))
+    end
+  end
+
+  # Display a link if user is authorized, otherwise nothing
+  # +name+    : String to be displayed
+  # +options+ : Hash containing
+  #             :controlller  : String or Symbol representing the controller
+  #             :auth_action  : String or Symbol representing the action to be used for authorization checks
+  # +html_options+ : Hash containing html options for the link or span
+  def display_link_if_authorized(name, options = {}, html_options = nil)
+    auth_action = options.delete :auth_action
+    link_to(name, options, html_options) if authorized_for(options[:controller] || params[:controller], auth_action || options[:action])
+  end
+
+  def authorized_edit_habtm klass, association
+    return edit_habtm(klass, association) if authorized_for params[:controller], params[:action]
+    show_habtm klass.send(association.name.pluralize.downcase)
+  end
+
 end
diff --git a/app/helpers/common_parameters_helper.rb b/app/helpers/common_parameters_helper.rb
index 8de8751..3eae3fd 100644
--- a/app/helpers/common_parameters_helper.rb
+++ b/app/helpers/common_parameters_helper.rb
@@ -1,2 +1,9 @@
 module CommonParametersHelper
+  # Return true if user is authorized for controller/action OR controller/action@type, otherwise false
+  def authorized_via_my_scope(controller, action)
+    return true if authorized_for(controller, action)
+
+    operation = "#{action}_my_#{controller.singularize}".to_sym
+    User.current.allowed_to?(operation) and User.current.send(controller).include?(eval("@#{controller.singularize}"))
+  end
 end
diff --git a/app/helpers/domains_helper.rb b/app/helpers/domains_helper.rb
index 04b2f61..80925d5 100644
--- a/app/helpers/domains_helper.rb
+++ b/app/helpers/domains_helper.rb
@@ -1,2 +1,3 @@
 module DomainsHelper
+  include CommonParametersHelper
 end
diff --git a/app/helpers/host_groups_helper.rb b/app/helpers/host_groups_helper.rb
index 7724b25..3250558 100644
--- a/app/helpers/host_groups_helper.rb
+++ b/app/helpers/host_groups_helper.rb
@@ -1,2 +1,3 @@
 module HostGroupsHelper
+  include CommonParametersHelper
 end
diff --git a/app/helpers/hostgroups_helper.rb b/app/helpers/hostgroups_helper.rb
index 337ce33..2132d78 100644
--- a/app/helpers/hostgroups_helper.rb
+++ b/app/helpers/hostgroups_helper.rb
@@ -1,2 +1,3 @@
 module HostgroupsHelper
+  include CommonParametersHelper
 end
diff --git a/app/helpers/hosts_helper.rb b/app/helpers/hosts_helper.rb
index f82f0f7..5396ccb 100644
--- a/app/helpers/hosts_helper.rb
+++ b/app/helpers/hosts_helper.rb
@@ -1,9 +1,11 @@
 module HostsHelper
+  include CommonParametersHelper
   def last_report_column(record)
     return nil if record.last_report.nil?
     time = time_ago_in_words(record.last_report.getlocal)
     image_tag("#{not (record.error_count > 0 or record.no_report)}.png", :size => "18x18") +
-      link_to_if(@last_reports[record.id], time, report_path(@last_reports[record.id].to_i))
+      link_to_if_authorized(time,  hash_for_report_path(:id => @last_reports[record.id], :enable_link => @last_reports[record.id])
+    )
   end
 
 # method that reformats the hostname column by adding the status icons
diff --git a/app/models/architecture.rb b/app/models/architecture.rb
index 1dd60ae..dccc436 100644
--- a/app/models/architecture.rb
+++ b/app/models/architecture.rb
@@ -1,4 +1,5 @@
 class Architecture < ActiveRecord::Base
+  include Authorization
   has_many :hosts
   has_and_belongs_to_many :operatingsystems
   validates_uniqueness_of :name
diff --git a/app/models/auth_source.rb b/app/models/auth_source.rb
index 4e17c7b..83bd4a7 100644
--- a/app/models/auth_source.rb
+++ b/app/models/auth_source.rb
@@ -16,6 +16,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 
 class AuthSource < ActiveRecord::Base
+  include Authorization
   has_many :users
 
   validates_presence_of :name
@@ -49,6 +50,7 @@ class AuthSource < ActiveRecord::Base
   end
 
   # Try to authenticate a user not yet registered against available sources
+  # Returns : user's attributes OR nil
   def self.authenticate(login, password)
     AuthSource.find(:all).each do |source|
       begin
diff --git a/app/models/auth_source_ldap.rb b/app/models/auth_source_ldap.rb
index 1347f4b..26c3b65 100644
--- a/app/models/auth_source_ldap.rb
+++ b/app/models/auth_source_ldap.rb
@@ -31,6 +31,9 @@ class AuthSourceLdap < AuthSource
     self.port = 389 if self.port == 0
   end
 
+  # Loads the LDAP info for a user and authenticates the user with their password
+  # Returns : Array of Strings.
+  #           Either the users's DN or the user's full details OR nil
   def authenticate(login, password)
     return nil if login.blank? || password.blank?
     attrs = []
diff --git a/app/models/authorization.rb b/app/models/authorization.rb
new file mode 100644
index 0000000..eb848d2
--- /dev/null
+++ b/app/models/authorization.rb
@@ -0,0 +1,41 @@
+module Authorization
+  def self.included(base)
+    base.class_eval do
+      before_save    :enforce_edit_permissions
+      before_destroy :enforce_destroy_permissions
+      before_create  :enforce_create_permissions
+    end
+  end
+
+  # We must enforce the security model
+  def enforce_edit_permissions
+    enforce_permissions("edit") if enforce?
+  end
+
+  def enforce_destroy_permissions
+    enforce_permissions("destroy") if enforce?
+  end
+
+  def enforce_create_permissions
+    enforce_permissions("create") if enforce?
+  end
+
+  def enforce_permissions operation
+    # We get called again with the operation being set to create
+    return true if operation == "edit" and new_record?
+
+    klass   = self.class.name.downcase
+    klass.gsub!(/authsource.*/, "authenticator")
+    klass.gsub!(/commonparameter.*/, "global_variable")
+    klasses = klass.pluralize
+    return true if User.current.allowed_to?("#{operation}_#{klasses}".to_sym)
+
+    errors.add_to_base "You do not have permission to #{operation} this #{klass}"
+    false
+  end
+
+  private
+  def enforce?
+    not (defined?(Rake) or User.current.admin?)
+  end
+end
diff --git a/app/models/domain.rb b/app/models/domain.rb
index e462731..86da39a 100644
--- a/app/models/domain.rb
+++ b/app/models/domain.rb
@@ -1,8 +1,11 @@
 # This models a DNS domain and so represents a site.
 class Domain < ActiveRecord::Base
+  include Authorization
   has_many :hosts
   has_many :subnets
   has_many :domain_parameters, :dependent => :destroy, :foreign_key => :reference_id
+  has_and_belongs_to_many :users, :join_table => "user_domains"
+
   accepts_nested_attributes_for :domain_parameters, :reject_if => lambda { |a| a[:value].blank? }, :allow_destroy => true
   validates_uniqueness_of :name
   validates_uniqueness_of :fullname, :allow_blank => true, :allow_nil => true
@@ -24,5 +27,24 @@ class Domain < ActiveRecord::Base
     super({:only => [:name, :id]}.merge(options))
   end
 
+  def enforce_permissions operation
+    # We get called again with the operation being set to create
+    return true if operation == "edit" and new_record?
+
+    current = User.current
+
+    if current.allowed_to?("#{operation}_domains".to_sym)
+      # If you can create domains then you can create them anywhere
+      return true if operation == "create"
+      # However if you are editing or destroying and you have a domain list then you are contrained
+      if current.domains.empty? or current.domains.map(&:id).include? self.id
+        return true
+      end
+    end
+
+    errors.add_to_base "You do not have permission to #{operation} this domain"
+    false
+  end
+
 end
 
diff --git a/app/models/domain_parameter.rb b/app/models/domain_parameter.rb
index fcff915..5392b0a 100644
--- a/app/models/domain_parameter.rb
+++ b/app/models/domain_parameter.rb
@@ -1,4 +1,21 @@
 class DomainParameter < Parameter
   belongs_to :domain, :foreign_key => :reference_id
   validates_uniqueness_of :name, :scope => :reference_id
+
+  private
+  def enforce_permissions operation
+    # We get called again with the operation being set to create
+    return true if operation == "edit" and new_record?
+
+    current = User.current
+
+    if current.allowed_to?("#{operation}_domains".to_sym)
+      if current.domains.empty? or current.domains.include? domain
+        return true
+      end
+    end
+
+    errors.add_to_base "You do not have permission to #{operation} this domain parameter"
+    false
+  end
 end
diff --git a/app/models/group_parameter.rb b/app/models/group_parameter.rb
index ec5c67f..2fce0c5 100644
--- a/app/models/group_parameter.rb
+++ b/app/models/group_parameter.rb
@@ -1,4 +1,21 @@
 class GroupParameter < Parameter
   belongs_to :hostgroup, :foreign_key => :reference_id
   validates_uniqueness_of :name, :scope => :reference_id
+
+  private
+  def enforce_permissions operation
+    # We get called again with the operation being set to create
+    return true if operation == "edit" and new_record?
+
+    current = User.current
+
+    if current.allowed_to?("#{operation}_hostgroups".to_sym)
+      if current.hostgroups.empty? or current.hostgroups.include? hostgroup
+        return true
+      end
+    end
+
+    errors.add_to_base "You do not have permission to #{operation} this group parameter"
+    false
+  end
 end
